use strict;
use XML::LibXML;

my $file = 'ch4_libxml_customers.xml';

# Instantiate a new XML::LibXML parser.
my $parser = XML::LibXML->new();

# Parse the XML document.
my $tree = $parser->parse_file($file);
my $root = $tree->getDocumentElement;

# Retrieve an array of all customers.
my @customers = $root->getElementsByTagName('customer');

my $total;

print "Accounts Receivable Report\n";
print "--------------------------\n";

# Loop through the array of all customers.
foreach my $customer (@customers) {
  my $account_num = $customer->getAttribute('account_number');
  print "Account Number: $account_num\n";

  my @name = $customer->getElementsByTagName('name');
  my $thisName = $name[0]->getFirstChild->getData;
  print "Customer Name: $thisName\n";

  my @balance = $customer->getElementsByTagName('balance');
  my $thisBalance = $balance[0]->getFirstChild->getData();
  print "Balance: \$$thisBalance\n";
  $total += $thisBalance;

  my @due_date = $customer->getElementsByTagName('due_date');
  my $thisDueDate = $due_date[0]->getFirstChild->getData();
  print "Due Date: $thisDueDate\n\n";
}

print "---------------------------\n";
print "Total Due: \$$total\n";



