use strict;
use XML::Generator::DBI;
use XML::Handler::YAWriter;
use DBI;

# Instantiate a new XML::Handler::YAWriter object.
my $ya = XML::Handler::YAWriter->new(AsFile => "-", 
				     Pretty => {PrettyWhiteNewline => 1,
						PrettyWhiteIndent => 1});

# Create a DBI connection
my $dbh = DBI->connect("dbi:CSV:f_dir=./");
$dbh->{RaiseError} = 1;

# Create a database table with columns named id and name.
$dbh->do("CREATE TABLE USERS (ID INTEGER, NAME CHAR(10))");

# Insert data into the database table.
$dbh->do("INSERT INTO USERS (ID, NAME) VALUES (1, 'Larry Wall')");
$dbh->do("INSERT INTO USERS (ID, NAME) VALUES (2, 'Tim Bunce')");
$dbh->do("INSERT INTO USERS (ID, NAME) VALUES (3, 'Matt Sergeant')");
$dbh->do("INSERT INTO USERS (ID, NAME) VALUES (4, 'Robin Berjon')");
$dbh->do("INSERT INTO USERS (ID, NAME) VALUES (5, 'Ilya Sterin')");

# Instantiate a new XML::Generator::DBI object.
my $generator = XML::Generator::DBI->new(
                       Handler => $ya,
                       dbh => $dbh);

# Execute the enclosed SQL query.
$generator->execute("SELECT ID, NAME FROM USERS");

# Remove the USERS table from the database.
$dbh->do("DROP TABLE USERS");

# Disconnect from the CSV database
$dbh->disconnect();
