use strict;
use DBI;
use XML::XMLtoDBMS;

# Instantiate a DBI connection to the source database.
my $dbh_from = DBI->connect(
                  "dbi:mysql:database=from_db;host=localhost", 
                  "root", 
                  "", 
                  {RaiseError => 1, PrintError => 0});

# Instantiate a new XMLtoDBMS object.
my $xmlToDbms = new XML::XMLtoDBMS($dbh_from);

# Identify the first XML document required.
$xmlToDbms->setMap('ch6_from_db.xml');

my $doc = $xmlToDbms->retrieveDocument('membership');

# Open an intermediate output file.
open (XML, ">ch6_middleware.xml") or 
  die "could not open file for writing: $! \n";
print XML $doc->toString;
close XML or die "error closing file 'ch6_middleware.xml': $!";

# Instantiate a DBI connection to the destination database.
my $dbh_to = DBI->connect(
                "dbi:mysql:database=to_db;host=localhost", 
                "root", 
                "", 
                {RaiseError => 1, PrintError => 0});

# Perform the mapping.
$xmlToDbms->{DBh} = $dbh_to;
$xmlToDbms->setMap('ch6_to_db.xml');
$doc = $xmlToDbms->storeDocument( Source => {File => 'ch6_middleware.xml'} );

$xmlToDbms->destroy;

# Disconnect from the source and destination databases.
$dbh_to->disconnect;
$dbh_from->disconnect;
