use strict;
use XML::LibXML;
use XML::LibXSLT;

# Instantiate parser and xslt objects.
my $parserObject = XML::LibXML->new();
my $xsltObject = XML::LibXSLT->new();

# Open the XML document and the XSLT stylesheet.
my $inputXmlObject = $parserObject->parse_file("ch8_libxslt_customers.xml");
my $inputStylesheetObject = $parserObject->parse_file("ch8_libxslt_customers.xslt");
#my $inputStylesheetObject = $parserObject->parse_file("table1.xslt");

# Parse the stylesheet, transform the input XML document,
# and output the result to the $htmlFile scalar.
my $xsltObject = $xsltObject->parse_stylesheet($inputStylesheetObject);
my $resultsObject = $xsltObject->transform($inputXmlObject);
my $htmlFile = $xsltObject->output_string($resultsObject);

# Write the results to an output file.
open (HTML_REPORT, "> ch8_libxslt_customer_report.html") 
  or die "Can't open ch8_libxslt_customer_report.html $!\n";

print HTML_REPORT $htmlFile;

close (HTML_REPORT);
