use strict;
use XML::Sablotron;

# Open the XSLT stylesheet.
open (XSLT, "ch8_sab_annual_report.xslt");
undef $/;
my $xslt = <XSLT>;
close XSLT;

# Open the input XML document.
open (INPUT_XML, "ch8_sab_annual_report.xml");
undef $/;
my $inputXML = <INPUT_XML>;
close INPUT_XML;

# Call the performTransform() subroutine, store the
# results in $transformedDoc.
my $transformedDoc = performTransform ($xslt, $inputXML);

# Write the results to an output file.
open (XML_REPORT, "> ch8_sab_filtered_report.xml") 
  or die "Can't open ch8_sab_filtered_report.xml $!\n";
print XML_REPORT $transformedDoc;

close (XML_REPORT);

###################################
sub performTransform {
  my ($xsltDoc, $xmlDoc) = @_;

  # Instantiate the new Sablotron objects.
  my $sabObject = new XML::Sablotron;
  my $sitObject = new XML::Sablotron::Situation;

  # Pass the required argments to the Sablotron objects.
  $sabObject->addArg($sitObject, 'xslt', $xsltDoc);
  $sabObject->addArg($sitObject, 'xml', $xmlDoc);

  # Perform the transformation.
  $sabObject->process($sitObject, 'arg:/xslt', 'arg:/xml', 'arg:/output');

  # Retrieve the results.
  my $result = $sabObject->getResultArg('arg:/output');

  return ($result);
}
