use strict;
use SOAP::Lite;

# ISBN come in as a command line argument
my $isbn = shift || 
  die "Must start the service with ISBN number\n";

print "Now searching for a book with ISBN # $isbn\n\n";

# Instantiate a SOAP::Lite object, passing in the ISBN
# number as an argument.
my $result = new SOAP::Lite
  ->uri('urn:Books')
  ->proxy('http://localhost/cgi-bin/book_service.cgi')
  ->getInfo($isbn);

# Print the result or error.
unless ($result->fault) {
  print $result->result();
} else {
  print join ', ',
    $result->faultcode,
    $result->faultstring,
    $result->faultfactor,
    $result->faultdetail;
}
